/*
 * blanco Framework
 * Copyright (C) 2004-2009 IGA Tosiki
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.sample.jsf.proxy;

import java.io.IOException;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.SQLException;

import javax.el.ELContext;
import javax.el.ELResolver;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

import blanco.sample.jsf.BlancoJsfSample1AddLogic;
import blanco.sample.jsf.BlancoJsfSample1ModifyLogic;
import blanco.sample.jsf.db.query.SimpleBookInsertInvoker;
import blanco.sample.jsf.db.query.SimpleBookSelectIterator;
import blanco.sample.jsf.util.BlancoJsfProxyUtil;

/**
 * JSF の Managed Bean と実際の処理とをつなぐプロキシ・クラス。
 *
 * <p>faces-config.xml には以下のように登録します。</p>
 * <pre>
 * &lt;managed-bean&gt;
 * 	&lt;managed-bean-name&gt;BlancoJsfSample1Logic&lt;/managed-bean-name&gt;
 * 	&lt;managed-bean-class&gt;blanco.sample.jsf.proxy.BlancoJsfSample1LogicProxy&lt;/managed-bean-class&gt;
 * &lt;managed-bean-scope&gt;request&lt;/managed-bean-scope&gt;
 * &lt;/managed-bean&gt;
 * </pre>
 */
@SuppressWarnings("serial")
public class BlancoJsfSample1LogicProxy extends String {
    /**
     * ページの処理結果。
     */
    private String fOutcome = "error";

    /**
     * クラスをインスタンス化して処理を実行する際のエントリポイントです。
     *
     * @param event イベント。
     */
    public final void add(final ActionEvent event) {
        final FacesContext ctx = FacesContext.getCurrentInstance();
        final ELContext elc = ctx.getELContext();
        final ELResolver rslvr = ctx.getApplication().getELResolver();

        // session から Managed Bean [integer] を取得します。
        final Integer argInteger = (Integer) rslvr.getValue(elc, null, "integer");

        final Connection conn = BlancoJsfProxyUtil.getConnection();
        boolean isLogicSuccess = false;
        final SimpleBookSelectIterator argSimpleBookSelectIterator = new SimpleBookSelectIterator(conn);
        final SimpleBookInsertInvoker argSimpleBookInsertInvoker = new SimpleBookInsertInvoker(conn);

        // 以下のコードでコンパイル・エラーが発生する場合には、クラス [blanco.sample.jsf.BlancoJsfSample1AddLogicImpl] を新規に作成してください。
        final BlancoJsfSample1AddLogic logic = new blanco.sample.jsf.BlancoJsfSample1AddLogicImpl();

        try {
            final String outcome = logic.execute(this, argInteger, argSimpleBookSelectIterator, argSimpleBookInsertInvoker, conn);

            conn.commit();
            isLogicSuccess = true;
            fOutcome = outcome;
            argSimpleBookSelectIterator.close();
            argSimpleBookInsertInvoker.close();
        } catch (IllegalArgumentException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (SQLException ex) {
            ex.printStackTrace();
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        if (isLogicSuccess == false) {
            try {
                conn.rollback();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        // コネクションの開放。
        BlancoJsfProxyUtil.releaseConnection(conn);
    }

    /**
     * クラスをインスタンス化して処理を実行する際のエントリポイントです。
     *
     * @param event イベント。
     */
    public final void modify(final ActionEvent event) {
        final FacesContext ctx = FacesContext.getCurrentInstance();
        final ELContext elc = ctx.getELContext();
        final ELResolver rslvr = ctx.getApplication().getELResolver();

        // session から Managed Bean [bigDecimal] を取得します。
        final BigDecimal argBigDecimal = (BigDecimal) rslvr.getValue(elc, null, "bigDecimal");
        // session から Managed Bean [integer] を取得します。
        final Integer argInteger = (Integer) rslvr.getValue(elc, null, "integer");

        final Connection conn = BlancoJsfProxyUtil.getConnection();
        boolean isLogicSuccess = false;
        final SimpleBookSelectIterator argSimpleBookSelectIterator = new SimpleBookSelectIterator(conn);

        // 以下のコードでコンパイル・エラーが発生する場合には、クラス [blanco.sample.jsf.BlancoJsfSample1ModifyLogicImpl] を新規に作成してください。
        final BlancoJsfSample1ModifyLogic logic = new blanco.sample.jsf.BlancoJsfSample1ModifyLogicImpl();

        try {
            logic.execute(this, argBigDecimal, argInteger, argSimpleBookSelectIterator, conn);

            conn.commit();
            isLogicSuccess = true;
            argSimpleBookSelectIterator.close();
        } catch (IllegalArgumentException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (SQLException ex) {
            ex.printStackTrace();
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        if (isLogicSuccess == false) {
            try {
                conn.rollback();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        // コネクションの開放。
        BlancoJsfProxyUtil.releaseConnection(conn);
    }

    /**
     * 実行結果を取得。
     *
     * @return 次画面情報。
     */
    public final String outcome() {
        return fOutcome;
    }
}
